7a58a86f967fdb114bb980a631292da2cee2a352
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 # For repeatability, reset the environment to known value.
7 LANG=C
8 LC_ALL=C
9 PAGER=cat
10 TZ=UTC
11 export LANG LC_ALL PAGER TZ
12 unset AUTHOR_DATE
13 unset AUTHOR_EMAIL
14 unset AUTHOR_NAME
15 unset COMMIT_AUTHOR_EMAIL
16 unset COMMIT_AUTHOR_NAME
17 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
18 unset GIT_AUTHOR_DATE
19 GIT_AUTHOR_EMAIL=author@example.com
20 GIT_AUTHOR_NAME='A U Thor'
21 unset GIT_COMMITTER_DATE
22 GIT_COMMITTER_EMAIL=committer@example.com
23 GIT_COMMITTER_NAME='C O Mitter'
24 unset GIT_DIFF_OPTS
25 unset GIT_DIR
26 unset GIT_EXTERNAL_DIFF
27 unset GIT_INDEX_FILE
28 unset GIT_OBJECT_DIRECTORY
29 unset SHA1_FILE_DIRECTORIES
30 unset SHA1_FILE_DIRECTORY
31 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
32 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
33
34 # Each test should start with something like this, after copyright notices:
35 #
36 # test_description='Description of this test...
37 # This test checks if command xyzzy does the right thing...
38 # '
39 # . ./test-lib.sh
40
41 error () {
42         echo "* error: $*"
43         trap - exit
44         exit 1
45 }
46
47 say () {
48         echo "* $*"
49 }
50
51 test "${test_description}" != "" ||
52 error "Test script did not set test_description."
53
54 while test "$#" -ne 0
55 do
56         case "$1" in
57         -d|--d|--de|--deb|--debu|--debug)
58                 debug=t; shift ;;
59         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
60                 immediate=t; shift ;;
61         -h|--h|--he|--hel|--help)
62                 echo "$test_description"
63                 exit 0 ;;
64         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
65                 verbose=t; shift ;;
66         *)
67                 break ;;
68         esac
69 done
70
71 exec 5>&1
72 if test "$verbose" = "t"
73 then
74         exec 4>&2 3>&1
75 else
76         exec 4>/dev/null 3>/dev/null
77 fi
78
79 test_failure=0
80 test_count=0
81
82 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
83
84
85 # You are not expected to call test_ok_ and test_failure_ directly, use
86 # the text_expect_* functions instead.
87
88 test_ok_ () {
89         test_count=$(expr "$test_count" + 1)
90         say "  ok $test_count: $@"
91 }
92
93 test_failure_ () {
94         test_count=$(expr "$test_count" + 1)
95         test_failure=$(expr "$test_failure" + 1);
96         say "FAIL $test_count: $1"
97         shift
98         echo "$@" | sed -e 's/^/        /'
99         test "$immediate" = "" || { trap - exit; exit 1; }
100 }
101
102
103 test_debug () {
104         test "$debug" = "" || eval "$1"
105 }
106
107 test_run_ () {
108         eval >&3 2>&4 "$1"
109         eval_ret="$?"
110         return 0
111 }
112
113 test_expect_failure () {
114         test "$#" = 2 ||
115         error "bug in the test script: not 2 parameters to test-expect-failure"
116         say >&3 "expecting failure: $2"
117         test_run_ "$2"
118         if [ "$?" = 0 -a "$eval_ret" != 0 ]
119         then
120                 test_ok_ "$1"
121         else
122                 test_failure_ "$@"
123         fi
124 }
125
126 test_expect_success () {
127         test "$#" = 2 ||
128         error "bug in the test script: not 2 parameters to test-expect-success"
129         say >&3 "expecting success: $2"
130         test_run_ "$2"
131         if [ "$?" = 0 -a "$eval_ret" = 0 ]
132         then
133                 test_ok_ "$1"
134         else
135                 test_failure_ "$@"
136         fi
137 }
138
139 test_expect_code () {
140         test "$#" = 3 ||
141         error "bug in the test script: not 3 parameters to test-expect-code"
142         say >&3 "expecting exit code $1: $3"
143         test_run_ "$3"
144         if [ "$?" = 0 -a "$eval_ret" = "$1" ]
145         then
146                 test_ok_ "$2"
147         else
148                 test_failure_ "$@"
149         fi
150 }
151
152 test_done () {
153         trap - exit
154         case "$test_failure" in
155         0)
156                 # We could:
157                 # cd .. && rm -fr trash
158                 # but that means we forbid any tests that use their own
159                 # subdirectory from calling test_done without coming back
160                 # to where they started from.
161                 # The Makefile provided will clean this test area so
162                 # we will leave things as they are.
163
164                 say "passed all $test_count test(s)"
165                 exit 0 ;;
166
167         *)
168                 say "failed $test_failure among $test_count test(s)"
169                 exit 1 ;;
170
171         esac
172 }
173
174 # Test the binaries we have just built.  The tests are kept in
175 # t/ subdirectory and are run in trash subdirectory.
176 PATH=$(pwd)/..:$PATH
177 GIT_EXEC_PATH=$(pwd)/..
178 export PATH GIT_EXEC_PATH
179
180 # Similarly use ../compat/subprocess.py if our python does not
181 # have subprocess.py on its own.
182 PYTHON=`sed -e '1{
183         s/^#!//
184         q
185 }' ../git-merge-recursive` || {
186         error "You haven't built things yet, have you?"
187 }
188 "$PYTHON" -c 'import subprocess' 2>/dev/null || {
189         PYTHONPATH=$(pwd)/../compat
190         export PYTHONPATH
191 }
192 test -d ../templates/blt || {
193         error "You haven't built things yet, have you?"
194 }
195
196 # Test repository
197 test=trash
198 rm -fr "$test"
199 mkdir "$test"
200 cd "$test" || error "Cannot setup test environment"
201 "$GIT_EXEC_PATH/git" init-db --template=../../templates/blt/ 2>/dev/null ||
202 error "cannot run git init-db -- have you built things yet?"
203
204 mv .git/hooks .git/hooks-disabled